/**
 * Arduino I2C Master 03
 * v. 1.0
 * Copyright (C) 2015 Robert Ulbricht
 *
 * I2C communication with second Arduino
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/ 

#include <Wire.h>

const byte SLAVE_ADDRESS = 42;
const byte LED = 13;

struct transfer_data
{
int16_t x; // same on all platforms - 2b
int y; // platform dependent - Arduino 2b
float value; // 4b
};

transfer_data td={10,20,1.2345};

void setup() 
  {
  Serial.begin(9600); 
  Serial.println("I2C Master 03");
  Serial.print("sizeof(transfer_data)=");
  Serial.println(sizeof(transfer_data));
  Serial.print("sizeof(td)=");
  Serial.println(sizeof(td));
  Wire.begin();
  pinMode(LED, OUTPUT);     
  }  // end of setup

void loop() 
  {
  for (byte x = 0; x < 10; x++)
    {
    td.x=10+x;
    td.y=10-x;
    td.value=1.2345*x;
    uint8_t *p=(uint8_t*)&td;
    Serial.print((int)x);
    Serial.print(", td.x=");
    Serial.print(td.x);
    Serial.print(", td.y=");
    Serial.print(td.y);
    Serial.print(", td.value=");
    Serial.print(td.value);
    
    unsigned int m=millis();
    Wire.beginTransmission(SLAVE_ADDRESS);
    Wire.write(p,sizeof(td)); // max 32b
    uint8_t ret=Wire.endTransmission ();
    if (ret == 0)
      {
      Serial.print(", ms=");
      Serial.print(millis()-m);
      Serial.println(" OK");
      digitalWrite (LED, HIGH); 
      }
    else
      {
      Serial.print(", ms=");
      Serial.print(millis()-m);
      Serial.println(" ERROR");
      digitalWrite (LED, LOW); 
      }
    Serial.print("ret=");
    Serial.println(ret);  
      
    delay (1000);
    }  // end of for loop
  }  // end of loop
