/**
 * Arduino I2C Slave 03
 * v. 1.0
 * Copyright (C) 2015 Robert Ulbricht
 *
 * I2C communication with second Arduino
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <Wire.h>

const byte MY_ADDRESS = 42;
int how;
boolean signal=false;
byte b;
struct transfer_data
{
int16_t x; // same on all platforms - 2b
int y; // platform dependent - Arduino 2b
float value; // 4b
};

transfer_data td={0,0,0.};

void setup () 
{
  Serial.begin(9600); 
  Serial.println("I2C Slave 03");
  Wire.begin (MY_ADDRESS);
  // set up receive handler
  Wire.onReceive (receiveEvent);
}  // end of setup

void loop() 
{
  if(signal)
  {
    Serial.print("how=");
    Serial.print(how);
    Serial.print(", td.x=");
    Serial.print(td.x);
    Serial.print(", td.y=");
    Serial.print(td.y);
    Serial.print(", td.value=");
    Serial.print(td.value);
    Serial.println("");
    signal=false;
    
    // now we want freeze interrupts to few seconds
    // disable interrupts
    cli();
    for(int j=0;j<200;j++)
    for(int i=0;i<32000;i++)
      {
       asm volatile("nop \n\t"
                    "nop \n\t"
                    "nop \n\t"
                    "nop \n\t"::); 
      }
    sei();
    // enable interrupts
  }
}

// called by interrupt service routine when incoming data arrives
void receiveEvent (int howMany)
{
  how=howMany;
  uint8_t *p=(uint8_t*)&td;

  for (int i = 0; i < howMany; i++)
  {
    b = Wire.read ();
    *p=b;
    p++;
  }  // end of for loop
  signal=true;
}  // end of receiveEvent

